/*
		NewObj.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class corresponding to the dialog of the same name.
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "NewObj.h"
#include "Obj.h"
#include "utils.h"
#include "World.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// NewObj dialog


NewObj::NewObj(CWnd* pParent /*=NULL*/)
	: CDialog(NewObj::IDD, pParent)
{
	//{{AFX_DATA_INIT(NewObj)
	m_new_obj_num = 0;
	//}}AFX_DATA_INIT
}


void NewObj::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NewObj)
	DDX_Text(pDX, IDC_NEW_OBJ_NUM, m_new_obj_num);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NewObj, CDialog)
	//{{AFX_MSG_MAP(NewObj)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NewObj message handlers
extern CCbreakApp theApp;

void NewObj::OnOK() 
{
  Obj *new_obj;
  map<int,Zone_Data>::const_iterator zi;
  int good=0,zone_num;

  extern World the_world;

  UpdateData(TRUE);
  
	/* check if it's already existing */
  if(the_world.obj_list.find(m_new_obj_num)!= the_world.obj_list.end()) {
	  AfxMessageBox("That obj already exists!",MB_OK);
	  return;
  }
  /* check if it's in a zone or not */

  for(zi=the_world.zone_list.begin();zi != the_world.zone_list.end() && !good;zi++) {
    if(m_new_obj_num >= zi->second.number * 100 && m_new_obj_num <= zi->second.top) {
			good=1;
			zone_num = zi->second.number;
		}
  }

  if(!good) {
		AfxMessageBox("That obj would exist outside a zone!",MB_OK);
	  return;
  }

	new_obj = new Obj;
	new_obj->zone = zone_num;
	new_obj->alias = "new obj";
	new_obj->sdesc = "nothing";
	new_obj->ldesc = "nothing";
	new_obj->adesc = "";
	new_obj->number = m_new_obj_num;
	
	the_world.obj_list[m_new_obj_num] = *new_obj;

	theApp.dlg->current_obj = m_new_obj_num;
	theApp.dlg->m_oedit.LoadOedit();
	CDialog::OnOK();
}
